<?PHP
require_once('stegmuffinimg1.0.1.php');

///////////////
// Functions //
///////////////

/*
//InputFile: displays an HTML <input> tag for uploading.
   $desc (string): description of the file to be uploaded
   $name (string): the name of the input field.
*/
function stegmuffin_inputfile($desc, $name) {
  echo "\n<p><b>".$desc.':</b> <input type="file" name="'.$name.'"';
  //If it's been posted but there's an error, display previous value.
  if(isset($_POST[$str.'_'.$name])) echo ' value="'.htmlentities($_POST[$name]).'"';
  echo' />';
  //Notice how it doesn't close the <p> tag -- that's so I don't have to include error handling here.
}

/*
//Form: Displays the entire form.
   $de (bool): If true, displays form for showing a hidden image. If false, displays the form for hiding an image in another.
   $errors (default false): If true, the form will be used to specify that an error has occurred with an attempted hiding/unhiding. Otherwise, an array of the specific errors will be passed through.
*/
function stegmuffin_form($de, $errors = false) {
  //Quick and easy string for 'show' and 'hide' so I don't need to do it every time.
  $str = ($de) ? 'show' : 'hide';
  //If there are errors, display a header.
  if($errors !== false) echo HEAD."\n<h2>Error</h2>\n<p>Unable to create image. See below for more details.</p>\n";
  ?>
<form enctype="multipart/form-data" method="post" action="stegmuffin<?= VERSION ?>.php">

<input type="hidden" name="MAX_FILE_SIZE" value="<? echo MAXSIZE; //This sets max-size in the HTML.?>"/>

<h2><?= ucfirst($str)?> Image</h2>
<? 
//Form for showing images.
if($de) {
  //Call to inputFile
  stegmuffin_inputfile('Image With Hidden Image',$str.'_file');
  // ... with error handling.
  if($errors['show-empty']) echo ' - <i>Please give a file.</i>';
  if($errors['show-notpng']) echo ' - <i>File is not a PNG image.</i>';
  if($errors['show-toobig']) echo ' - <i>Please select a file smaller than 1 MB.</i>';
  echo '</p>';
}
// Form for hiding images.
else {
  //Call to inputFile
  stegmuffin_inputfile('Cover Image',$str.'_cover');
  
  // More error handling.
  if($errors['hide-empty1']) echo ' - <i>Please give a file.</i>';
  if($errors['hide-notpng']) echo ' - <i>File is not a valid image.</i>';
  if($errors['hide-toobig1']) echo ' - <i>Please select a file smaller than 1 MB.</i>';
  echo '</p>';
  
  //More input file!
  stegmuffin_inputfile('Image To Hide',$str.'_file');
  
  //More error handling!
  if($errors['hide-empty2']) echo ' - <i>Please give a file.</i>';
  if($errors['hide-toobig2']) echo ' - <i>Please select a file smaller than 1 MB.</i>';
  if($errors['hide-nottype']) echo ' - <i>File is not a valid image.</i>';
  if($errors['hide-notsize']) echo ' - <i>The images aren\'t the same size (width and height).</i>';
  echo '</p>';
}
?>
<p><b>Number of bits:</b> <select name="<?= $str?>_bits">
<?
//A little for-loop to facilitate options for the number of bits.
for($optn = 1; $optn <= 4; $optn++) {
  echo "\n<option value=\"".$optn;
  if((int)$_POST[$str.'_bits'] == $optn) echo '" selected="1';
  elseif($optn == 2) echo '" selected="1';
  echo '">'.$optn.'</option>';
} ?>
</select></p>

<p><input type="submit" name="<?= $str?>_submit" value="Download"/> <input type="submit" name="<?= $str?>_submitview" value="View"/> <a href="stegmuffin.php">Reset</a></p>
</form>
<?
  //If there are errors, echo the footer and then end the program.
  if($errors !== false) {
    echo FOOT;
    die;
  }
}
/*
//bittify - Converts the number of bits to a helpful binary number, i.e. 3 bits = 0111 ...
   $num (int) - number of bits to go after.
*/
function stegmuffin_bittify($num) {
  //RETURN: (2^$num)-1.
  return (pow(2,$num)-1);
}

/*
//quickdie - for when I want to handle an error really quickly.
   $errory (string) - what error to produce.
   $whichform (bool) - true if showing, false if hiding.
*/
function stegmuffin_quickdie($errory, $whichform = FALSE) {
  //Set the value in the errors-array.
  $errors[$errory] = TRUE;
  //Start the form.
  stegmuffin_form($whichform,$errors);
}
/*
//handle - For when I want to handle an error not quite so quickly.
   $errors - Array of errors.
   $whichform (bool) - true if showing, false if hiding.
*/
function stegmuffin_handle($errors = array(), $whichform = FALSE) {
  //If there are any errors, give the form.
  if(in_array(TRUE,$errors)) stegmuffin_form($whichform,$errors);
}

////////////////
// Show Image //
////////////////
if(isset($_POST['show_submit']) | isset($_POST['show_submitview'])) {
  //Intitialize "errors" as an empty array.
  $errors = array();
  //Error checking - did they even put ANYTHING in!?
  if(empty($_FILES['show_file']['name'])) stegmuffin_quickdie('show-empty',TRUE);
  
  //Get the extension of the file.
  $oldType = end(explode(".", strtolower($_FILES['show_file']['name'])));
  //If it's not a PNG, handle the error.
  if($oldType != 'png') $errors['show-notpng'] = TRUE;
  //If it's bigger than the max size, handle the error.
  if($_FILES['show_file']['size'] > MAXSIZE) $errors['show-toobig'] = TRUE;
  
  //If there are any errors, handle them!
  stegmuffin_handle($errors,TRUE);
  
  //Unset $oldType to free up RAM when done. We're gonna be doing a lot of this ...
  unset($oldType);
  
  //Generate an image from the file with the hidden image.
  $oldImage = @imagecreatefrompng($_FILES['show_file']['tmp_name']) or stegmuffin_imgerr('access uploaded image');
  
  //Stuff it into an image!
  stegmuffin_showimg($oldImage,(int)$_POST['show_bits'],isset($_POST['show_submit']));
}
////////////////
// Hide Image //
////////////////
elseif(isset($_POST['hide_submit']) | isset($_POST['hide_submitview'])) {
  //Initializes errors.
  $errors = array();
  
  //Error checking - did they even put ANYTHING in!?
  if(empty($_FILES['hide_cover']['name'])) $errors['hide-empty1'] = TRUE;
  if(empty($_FILES['hide_file']['name'])) $errors['hide-empty2'] = TRUE;
  //Handle errors.
  stegmuffin_handle($errors);
  
  //Sets the allowed types for the hidden image, since I only understand those ones.
  $allowedtypes = array('bmp','gif','png','jpg','jpeg');
  $hidType = end(explode(".", strtolower($_FILES['hide_file']['name'])));
  //And error handling for that.
  if(!in_array($hidType,$allowedtypes)) $errors['hide-nottype'] = TRUE;
  unset($allowedTypes);
  
  //The cover image has to be a PNG or BMP.
  $covType = end(explode(".", strtolower($_FILES['hide_cover']['name'])));
  if($covType != 'png' && $covType != 'bmp') $errors['hide-notpng'] = TRUE;
  
  //And it needs to be smaller than the max size.
  if($_FILES['hide_file']['size'] > MAXSIZE) $errors['hide-toobig1'] = TRUE;
  if($_FILES['hide_cover']['size'] > MAXSIZE) $errors['hide-toobig2'] = TRUE;
  
  //Handle errors.
  stegmuffin_handle($errors);
  
  //Create hidden-image from the proper file-type!
  switch($hidType) {
     case 'bmp': $hidImage = @imagecreatefrombmp($_FILES['hide_file']['tmp_name']); break;
     case 'gif': $hidImage = @imagecreatefromgif($_FILES['hide_file']['tmp_name']); break;
     case 'png': $hidImage = @imagecreatefrompng($_FILES['hide_file']['tmp_name']); break;
     default: $hidImage = @imagecreatefromjpeg($_FILES['hide_file']['tmp_name']);;
  }
  if($hidImage === FALSE) stegmuffin_imgerr('access uploaded hidden-image');
  unset($hidType);
  
  //Create the cover-image.
  if($covType == 'png') $covImage = @imagecreatefrompng($_FILES['hide_cover']['tmp_name']);
  else $covImage = @imagecreatefrombmp($_FILES['hide_cover']['tmp_name']);
  if($covImage === FALSE) stegmuffin_imgerr('access uploaded cover-image');
  unset($covType);
  
  //Get image-size for both of them.
  $imgsize = getimagesize($_FILES['hide_file']['tmp_name']) or stegmuffin_imgerr('get hidden-image size');
  $covsize = getimagesize($_FILES['hide_cover']['tmp_name']) or stegmuffin_imgerr('get cover-image size');
  
  //If one of them is the wrong size, kill it!
  if(($imgsize[0] != $covsize[0]) | ($imgsize[1] != $covsize[1])) stegmuffin_quickdie('hide-notsize');
  unset($covsize);
  
  //Stuff it into an image!
  stegmuffin_hideimg($hidImage,$covImage,(int)$_POST['hide_bits'],isset($_POST['hide_submit']));
}
//////////////////
// Introduction //
//////////////////
else {
  echo HEAD;
  //If I wanted to do it without a frame, I'd do this here.
  if(!$_GET['nointro']) {
    ?>
<p>Current version: <?= VERSION.'/'.DATE ?></p>

<p>This tool enables you to hide an image in another image, <a href="http://en.wikipedia.org/wiki/Steganography">without anyone knowing they were there</a>. Simply select the image you want to hide and the cover image &mdash; they MUST be the same size, and the cover image MUST be PNG or BMP. Alternatively, if you have an image you want to reveal, use that instead; it MUST be a PNG. All images must be smaller than 1 megabyte in size. Please save it to your hard drive right away (this might not work if you choose View); it is NOT stored on the server for any length of time. Also note that </p>

<p>You'll probably want to experiment to see what kind of cover-image works and what doesn't for a particular hidden-image. StegMuffin is not in any way responsible for the fact that if you select a number of bits which is too high, the hidden image is <i>really</i> freaking obvious.</p>
<?PHP
  }
    //Display both forms.
    stegmuffin_form(false);
    stegmuffin_form(true);
echo FOOT;
die;
}
?>