<?PHP
require_once('stegmuffinimg1.0.2.php');

///////////////
// Functions //
///////////////

/*
//InputFile: displays an HTML <input> tag for uploading.
   $desc (string): description of the file to be uploaded
   $name (string): the name of the input field.
*/
function stegmuffin_inputfile($desc, $name) {
  echo "\n<p><b>".$desc.':</b> <input type="file" name="'.$name.'"';
  //If it's been posted but there's an error, display previous value.
  if(isset($_POST[$str.'_'.$name])) echo ' value="'.htmlentities($_POST[$name]).'"';
  echo' />';
  //Notice how it doesn't close the <p> tag -- that's so I don't have to include error handling here.
}

/*
//Form: Displays the entire form.
   $de (bool): If true, displays form for showing a hidden image. If false, displays the form for hiding an image in another.
   $errors (default false): If true, the form will be used to specify that an error has occurred with an attempted hiding/unhiding. Otherwise, an array of the specific errors will be passed through.
*/
function stegmuffin_form($de, $errors = false) {
  //Quick and easy string for 'show' and 'hide' so I don't need to do it every time.
  $str = ($de) ? 'show' : 'hide';
  //If there are errors, display a header.
  if($errors !== false) echo HEAD."\n<h2>Error</h2>\n<p>Unable to create image. See below for more details.</p>\n";
  ?>
<form enctype="multipart/form-data" method="post" action="stegmuffin<?= VERSION ?>.php">

<input type="hidden" name="MAX_FILE_SIZE" value="<? echo MAXSIZE; //This sets max-size in the HTML.?>"/>

<h2><?= ucfirst($str)?> Image</h2>
<? 
//Form for showing images.
if($de) {
  //Call to inputFile
  stegmuffin_inputfile('Image With Hidden Image',$str.'_file');
  // ... with error handling.
  if($errors['show-empty']) echo ' - <i>Please give a file.</i>';
  if($errors['show-notpng']) echo ' - <i>File is not a PNG image.</i>';
  if($errors['show-toobig']) echo ' - <i>Please select a file smaller than 1 MB.</i>';
  echo '</p>';
}
// Form for hiding images.
else {
  //Call to inputFile
  stegmuffin_inputfile('Cover Image',$str.'_cover');
  
  // More error handling.
  if($errors['hide-empty1']) echo ' - <i>Please give a file.</i>';
  if($errors['hide-notpng']) echo ' - <i>File is not a valid image.</i>';
  if($errors['hide-toobig1']) echo ' - <i>Please select a file smaller than 1 MB.</i>';
  echo '</p>';
  
  //More input file!
  stegmuffin_inputfile('Image To Hide',$str.'_file');
  
  //More error handling!
  if($errors['hide-empty2']) echo ' - <i>Please give a file.</i>';
  if($errors['hide-toobig2']) echo ' - <i>Please select a file smaller than 1 MB.</i>';
  if($errors['hide-nottype']) echo ' - <i>File is not a valid image.</i>';
  if($errors['hide-notsize']) echo ' - <i>The images aren\'t the same size (width and height).</i>';
  echo '</p>';
}
?>
<p><b>Number of bits:</b> <select name="<?= $str?>_bits">
<?
//A little for-loop to facilitate options for the number of bits.
for($optn = 1; $optn <= 4; $optn++) {
  echo "\n<option value=\"".$optn;
  if((int)$_POST[$str.'_bits'] == $optn) echo '" selected="1';
  elseif($optn == 2) echo '" selected="1';
  echo '">'.$optn.'</option>';
} ?>
</select></p>

<p><input type="submit" name="<?= $str?>_submit" value="Download"/> <input type="submit" name="<?= $str?>_submitview" value="View"/> <a href="stegmuffin.php">Reset</a></p>
</form>
<?
  //If there are errors, echo the footer and then end the program.
  if($errors !== false) {
    echo FOOT;
    die;
  }
}
/*
//bittify - Converts the number of bits to a helpful binary number, i.e. 3 bits = 0111 ...
   $num (int) - number of bits to go after.
*/
function stegmuffin_bittify($num) {
  //RETURN: (2^$num)-1.
  return (pow(2,$num)-1);
}

/*
//quickdie - for when I want to handle an error really quickly.
   $errory (string) - what error to produce.
   $whichform (bool) - true if showing, false if hiding.
*/
function stegmuffin_quickdie($errory, $whichform = FALSE) {
  //Set the value in the errors-array.
  $errors[$errory] = TRUE;
  //Start the form.
  stegmuffin_form($whichform,$errors);
}
/*
//handle - For when I want to handle an error not quite so quickly.
   $errors - Array of errors.
   $whichform (bool) - true if showing, false if hiding.
*/
function stegmuffin_handle($errors = array(), $whichform = FALSE) {
  //If there are any errors, give the form.
  if(in_array(TRUE,$errors)) stegmuffin_form($whichform,$errors);
}
?>